{$A-,B-,D-,E+,F-,G+,I-,L-,N+,O-,P-,Q-,R-,S-,T-,V-,X+}
{$M $400,0,$40000}
(*)-- Pascal Support ------------------------------------------------
    Demo by Victor Shantar [2:5054/26@fidonet]
---------------------------------------- http://attend.to/virgi --(*)
Uses mycrt;

type tscreen=array[0..199,0..319] of byte;
     simb=array[1..20,1..8] of byte;
     SinTabType = Array[0..1023] of Integer;
     SinTabPtr  = ^SinTabType;

     pWaterDemo=^tWaterDemo;
     tWaterDemo=Object
       SinTab                       : SinTabPtr;
       Ang1,Ang2                    : Integer;
       Px,Py,Height                 : Integer;
       videoadres:pointer;
       Constructor Init(iva:pointer);
       Procedure SetupSinTab; virtual;
       Procedure DrawRipples; virtual;
       Procedure Next; virtual;
       Destructor Done; virtual;
     end;

     tPoint=record
       x,y,z:double;
     end;

     pPoints=^tPoints;
     tPoints=array[1..2000] of tPoint;

     tSpiral=object
       last:pPoints;
       count:word;
       dx,dy,dz:integer;
       sint,cost:double;
       videoadres:pointer;
       Constructor Init(iva:pointer);
       Procedure AddPoint; virtual;
       Procedure Rotate; virtual;
       Procedure Next; virtual;
       Destructor Done; virtual;
     end;

Const
   SinTabSize                   = 1024;

Var OutBuffer:^tscreen;
    video:tscreen absolute $A000:0;

Procedure SetRGBColor(c,r,g,b:byte);
begin
  port[$3C8]:=c;
  port[$3C9]:=r;
  port[$3C9]:=g;
  port[$3C9]:=b;
end;

Procedure GetRGBColor(c,r,g,b:byte);
begin
  port[$3C8]:=c;
  port[$3C9]:=r;
  port[$3C9]:=g;
  port[$3C9]:=b;
end;


Constructor tWaterDemo.Init;
begin
  videoadres:=iva;
  New(SinTab);
  SetupSinTab;
  DrawRipples;
end;

Procedure tWaterDemo.SetupSinTab;
Var
   n                            : Integer;
   a,ast                        : Real;
Begin
   a:=0;
   ast:=2*pi/SinTabSize;
   For n:=0 to SinTabSize-1 do
   Begin
      SinTab^[n]:=Round(128*Sin(a));
      a:=a+ast
   End
End;

Procedure tWaterDemo.DrawRipples;
Begin
   Ang1:=0;
   Ang2:=0;
end;

Procedure tWaterDemo.Next;
var z,x:integer;
    out:^tscreen;
begin
   out:=videoadres;
   FillChar(Out^,64000,200);
   For z:=-30 to -10 do
      For x:=-20 to 20 do
      Begin
         Height:=
                 SinTab^[(Ang1+x*32) and (SinTabSize-1)]+
                 SinTab^[(Ang2+z*32) and (SinTabSize-1)];
         Px:=64*x div z;
         Py:=(Height+240) div z;
         Out^[99-py,159+px]:=31-((height+256) div 64);
   End;
   Ang1:=Ang1+17;
   Ang1:=Ang1 and (SinTabSize-1);
   Ang2:=Ang2+12;
   Ang2:=Ang2 and (SinTabSize-1);
End;

Destructor tWaterDemo.Done;
begin
  dispose(SinTab);
end;
{-----------------------------------------------------------------------}

Constructor tSpiral.Init;
var i,r,g,b:byte;
begin
  videoadres:=iva;
  randomize;
  r:=3+random(4);g:=3+random(4);b:=3+random(4);
  for i:=0 to 20 do setrgbcolor(i,(i div 2)*r,(i div 2)*g,(i div 2)*b);
  for i:=21 to 25 do setrgbcolor(i,10*r,10*g,10*b);
  sint:=sin(pi/180);
  cost:=cos(pi/180);
  last:=nil; new(last);
  with last^[1] do begin
    z:=0; x:=0; y:=0;
  end;
  count:=1;
  dx:=random(5)-2;
  dy:=random(5)-2;
  dz:=random(5)-2;
end;

Procedure tSpiral.AddPoint;
begin
  inc(count); last^[count]:=last^[count-1];
  with last^[count] do begin
    x:=x+dx/20; y:=y+dy/20; z:=z+dz/20;
    if z<-1.5 then begin z:=-1.5; dz:=-dz end;
    if z>1.5 then begin z:=1.5; dz:=-dz end;
    if x<-1.5 then begin x:=-1.5; dx:=-dx end;
    if x>1.5 then begin x:=1.5; dx:=-dx end;
    if y<-1.5 then begin y:=-1.5; dy:=-dy end;
    if y>1.5 then begin y:=1.5; dy:=-dy end;
    if random(5)=0 then dx:=random(5)-2;
    if random(5)=0 then dy:=random(5)-2;
    if random(5)=0 then dz:=random(5)-2;
  end;
end;

Procedure tSpiral.Rotate;
var t:word;
begin
  for t:=1 to count do
    with last^[t] do begin
      x:=(x*(cost))+(z*(sint));
      z:=-(x*(sint))+(z*(cost))
    end;
end;

Procedure tSpiral.Next;
const ball:array[0..9,0..9] of byte=(
                 ( 00,00,00,01,01,01,01,00,00,00),
                 ( 00,00,01,02,02,02,02,01,00,00),
                 ( 00,01,02,03,03,03,03,02,01,00),
                 ( 01,02,03,04,04,04,04,03,02,01),
                 ( 01,02,03,04,05,05,04,03,02,01),
                 ( 01,02,03,04,05,05,04,03,02,01),
                 ( 01,02,03,04,04,04,04,03,02,01),
                 ( 00,01,02,03,03,03,03,02,01,00),
                 ( 00,00,01,02,02,02,02,01,00,00),
                 ( 00,00,00,01,01,01,01,00,00,00));
var x2,y2:integer; i,j,k,h,r,g,b:byte; t:word; ot:longint absolute $40:$6c;
    m:longint; out:^tscreen;
begin
  out:=videoadres;
  m:=ot;
  fillchar(out^,64000,0);
  for t:=1 to count do begin
    with last^[t] do begin
      x2:=round(50*x);
      y2:=round(50*y);
    end;
    if (y2+100>=0) and (y2+100<200) and (x2+159>=0) and (x2+159<319) then
    for i:=0 to 9 do for j:=0 to 9 do begin
      k:=ball[i,j]; h:=out^[y2+100+i,x2+159+j];
      if h<20 then inc(out^[y2+100+i,x2+159+j],k);
      h:=out^[y2+100+i,x2+159+j];
    end;
  end;
  Rotate;
  if count<2000 then AddPoint;
  repeat until ot-m>3;
  if random(30)=0 then begin
    r:=3+random(4);g:=3+random(4);b:=3+random(4);
    for i:=0 to 20 do setrgbcolor(i,(i div 2)*r,(i div 2)*g,(i div 2)*b);
    for i:=21 to 25 do setrgbcolor(i,10*r,10*g,10*b);
  end;
end;

Destructor tSpiral.Done;
begin
  dispose(last);
end;

{-----------------------------------------------------------------------}

Procedure OpenRegs; near; assembler;
Asm
  cli
  mov dx,03C4h
  mov ax,0402h
  out dx,ax
  mov ax,0704h
  out dx,ax
  mov dl,0CEh
  mov ax,0204h
  out dx,ax
  mov ax,0005h
  out dx,ax
  mov ax,0406h
  out dx,ax
End;

Procedure CloseRegs; near; assembler;
Asm
  mov dx,03C4h
  mov ax,0302h
  out dx,ax
  mov ax,0304h
  out dx,ax
  mov dl,0CEh
  mov ax,0004h
  out dx,ax
  mov ax,1005h
  out dx,ax
  mov es,Seg0040
  mov ax,0E06h
  cmp byte ptr es:[0049h],07h
  jne @color
  mov ax,0A06h
@color:
  out dx,ax
  sti
End;

Procedure SaveCharset(var Buffer; StartChar, Count, ScanLines : word); assembler;
Asm
  call OpenRegs
  push ds
  mov ax,SegA000
  mov ds,ax
  mov ax,StartChar
  mov bx,32
  mul bx
  mov si,ax
  les di,Buffer
  cld
  mov ax,Count
  mul bx
  mov dx,ScanLines
@@1:
  mov cx,dx
  rep movsb
  mov cx,bx
  sub cx,dx
  add si,cx
  sub ax,bx
  cmp ax,0
  jnz @@1
  pop ds
  call CloseRegs
End;


type tfont=array[1..255] of simb;
var font:^tfont;

Procedure ReadFont(fanky,blood:boolean); {ᥫ_,஢}
type tchar=array[1..16] of byte;
var i,j:byte; char_:tchar;

Function dec2bin(l:longint):string;
var i:byte; j:longint; s:string;
begin
  s:=''; j:=1; if l=0 then s:='00000000';
  while j<=l do begin
    if l and j=j then s:='1'+s else s:='0'+s;
    j:=2*j;
  end;
  while s[0]<#8 do s:='0'+s;
  dec2bin:=s;
end;

var s:string; k,r:byte;

begin
  randomize; r:=0;
  for i:=0 to 255 do begin
    SaveCharSet(char_,i,1,16);
    if fanky then r:=random(3);
    for j:=1 to 20 do begin
      if j<17 then s:=dec2bin(char_[j]) else s:='00000000';
      case r of
	1:if j>8 then s:=copy(s,2,8)+'0';
	2:if j>8 then s:='0'+copy(s,1,7);
      end;
      for k:=1 to 8 do begin
	if s[k]='1' then begin
	    font^[i,j,k]:=251+j div 4;
	  if k>1 then if (s[k-1]='0') and (j div 4<2) then
	    font^[i,j,k]:=251
	  else else if j div 4<2 then font^[i,j,k]:=251;
	end else begin
	  font^[i,j,k]:=0;
	  if blood and (j>1) and (font^[i,j-1,k]<>0) then
	    if random(j div 2)=0 then font^[i,j,k]:=252;
	end;
      end;
    end;
  end;
end;


Procedure PutChar(x,y:word; c:char; jump:boolean; var where:tscreen);
var i,j:byte; cc:byte; a,b:word;
begin
  cc:=byte(c); if jump then y:=y+random(3)-1;
  for i:=1 to 20 do begin
    a:=y+i-1; if (a>=0) and (a<200) then
      for j:=1 to 8 do begin
	b:=x+j-1; if (b>=0) and (b<319) then where[a,b]:=font^[cc,i,j];
      end;
  end;
end;

Procedure PutString(x,y:word; s:string; jump:boolean; var where:tscreen);
var r:byte;
begin
  for r:=1 to length(s) do PutChar(x+(r-1)*8,y,s[r],jump,where);
end;


Procedure Flip(var from_, to_:tscreen);
var a,b:word;
begin
  a:=seg(from_);
  b:=seg(to_);
asm
  push ds
  mov ds,a
  mov es,b
  xor si,si
  xor di,di
  mov cx,16000
  db 66h; rep movsw
  pop ds
end;
end;

Procedure PutPic(X: Word;Y:Byte;VAR sprt;W,H:word;Where:Word); ASSEMBLER;
  {W=ਭ, H=, Sprt=ࠩ (ᨢ 祪) }
label
  _Redraw, _DrawLoop, _Exit, _LineLoop, _NextLine, _Ignore;

asm
    push  ds
    and   bl, 0
    mov   es, where   {  ᥣ⭮  Where  ES:DI}
    lds   si, Sprt    { ⥭  ࠩ  DS:SI }
    mov   di, x

    {᫥୨ ᬥ饭 (y*320)+x}
    mov   bh, y       { bx = y*256 }
    mov   ax, bx      {   Y }
    shr   ax, 2       { y2 = y2 * 64}
    add   bx, ax      {  ᬥ饭 : y = y1+y2 (y=y*320) }
    add   di, bx      { 쭮 ᬥ饭 (Y*320)+X }

    cld
    and   ch, 0
    mov   ax,H        {  AX  }

_DrawLoop:
    mov   dx,di        { ࠭ ᬥ饭   ᯮ짮 }
    mov   cx,W       {  CX ਭ }
_LineLoop:
    mov   bl,byte ptr [si]
    or    bl,bl       { ஢ઠ   }
    jz    _Ignore     { ᫨ ,  㥬 }
    movsb
    loop   _LineLoop
    jmp    _NextLine

_Ignore:
    inc    si
    inc    di
    loop  _LineLoop

_NextLine:
    mov   di,dx
    dec   ax           {   }
    jz    _Exit
    add   di,140h
    jmp   _DrawLoop

_Exit:
    pop   ds
end;

Procedure FlipZero(var where1,where2:tscreen);
begin
  PutPic(0,0,where1,320,200,seg(where2));
end;

procedure smooth(var where:tscreen);
var b:word;
begin
  b:=seg(where);
asm
  mov es,b
  xor di,di
  mov cx,64000-320
  xor bh,bh
  @@loop:
  xor ax,ax
  mov al,es:[di]
  mov bl,es:[di+320] ;add ax,bx
  mov bl,es:[di+1]   ;add ax,bx
  mov bl,es:[di+321] ;add ax,bx
  shr ax,2
  mov es:[di],al
  inc di
  loop @@loop
end; end;

var buff:^tscreen;
    i,j:byte; c:char;
    w:pWaterDemo; sp:^tSpiral;

const ttext:array[1..2] of string[12] = (
'Downloaded',' from bpascal.ru.');

begin
  randomize;
  new(font); readfont(random(2)=0,random(2)=0);
  new(OutBuffer);
  new(buff);
  SetRgbColor(251,48,17,17);
  SetRgbColor(252,40,10,10);
  SetRgbColor(253,40,8,8);
  SetRgbColor(254,35,6,6);
  asm mov ax,13h; int 10h end;

  fillchar(buff^,64000,0);
  For I:=1 to 2 do
    PutString(159-length(ttext[i]) * 4,(I-1)*16,ttext[i],random(2)=0,buff^);

  setrgbcolor(200,3,4,10);
  new(w,init(outbuffer));
  repeat
    w^.next;
    FlipZero(buff^,outbuffer^);
    waitretrace;
    flip(outbuffer^,video);
  until keypressed;
  dispose(w,done);
  readkey;
  for i:=0 to 230 do setrgbcolor(i,3,4,10);
  for i:=0 to 20 do setrgbcolor(i+230,i*3,0,0);
  flip(video,outbuffer^);
  for i:=1 to 20 do begin
    smooth(outbuffer^);
    flip(outbuffer^,video);
  end;

  fillchar(video,64000,0);

  SetRgbColor(251,48,17,17);
  SetRgbColor(252,40,10,10);
  SetRgbColor(253,40,8,8);
  SetRgbColor(254,35,6,6);

  fillchar(buff^,64000,0);
  For I:=13 to 24 do
    PutString(159-length(ttext[i]) * 4,(I-13)*16,ttext[i],random(2)=0,buff^);

  new(sp,init(outbuffer));
  repeat
    sp^.next;
    FlipZero(buff^,outbuffer^);
    waitretrace;
    flip(outbuffer^,video);
  until keypressed;
  dispose(sp,done);
  readkey;
  for i:=0 to 230 do setrgbcolor(i,0,0,0);
  for i:=0 to 60 do setrgbcolor(i+190,i,0,0);
  flip(video,outbuffer^);
  for i:=1 to 20 do begin
    smooth(outbuffer^);
    flip(outbuffer^,video);
  end;

  asm mov ax,3; int 10h end;
  dispose(buff);
  dispose(OutBuffer);
  dispose(font);
end.